	device zxspectrum48
        ORG #6000
temptab	equ $BC00 ; temporary data for game
gamemap equ temptab+256
begin
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir;debug grid
	ld sp,$5FFF
	ld a,$44:call cls
	di
	;ld hl,song:call INIT
;	jr $
	ld hl,music_b,de,$C000,bc,music_e-music_b:ldir
	call $C000
	di
	ld hl,$BE00,de,$BE01,bc,256,(hl),$BF:ldir
	ld a,$C3,($BFBF),a
	ld hl,intvec,($BFC0),hl
	ld a,$BE,i,a
	im 2
	ei

	ld a,$45,($5948),a,($5968),a,($5988),a
	ld a,$46,($59A8),a
	ld a,$47,($59C8),a
	ld a,$43,($5908+4),a

	ld hl,tx1:call prtext
	ld hl,tx5:call prtext
pasprn:
	ld hl,tx4:call prtext
beginprt:
	ld hl,tx2:call prtext
	ld hl,tx3:call prtext
	ld hl,tx6:call prtext

keylp:
	ld a,$F7:in a,($FE)
	bit 0,a:jr nz,key2
	ld a,128,(tx2+2),a
	ld a,32,(tx3+2),a
	ld a,32,(tx6+2),a
	jp beginprt
key2:
	bit 1,a:jr nz,key3
	ld a,32,(tx2+2),a
	ld a,32,(tx6+2),a
	ld a,128,(tx3+2),a
	jp beginprt
key3:
	bit 2,a:jr nz,key4
	ld a,32,(tx2+2),a
	ld a,32,(tx3+2),a
	ld a,128,(tx6+2),a
	jp beginprt
key4:
	bit 3,a:jp nz,key0
	call wk
;	jr $
;input password
	ld ix,$5992-3+32
	ld hl,tx44
	ld b,4
ilp:
	ld a,(ix+0)
	xor 12
	ld (ix+0),a
kk:
	push hl,ix,bc
	call getkey
	pop bc,ix,hl
	cp $41:jr c,kk
	ld (hl),a:inc hl
	ld a,(ix+0)
	xor 12
	ld (ix+0),a
	inc ix
	push hl,ix,bc
	ld hl,tx4:call prtext
	pop bc,ix,hl
	ei:halt
	call wk
	djnz ilp
; split to nibbles
	ld hl,tx44
	ld de,kbuf
	ld b,4
spl_lp:
	ld a,(hl)
	srl a
	srl a
	srl a
	srl a
	ld (de),a:inc de
	ld a,(hl)
	and 15
	ld (de),a:inc de
	inc hl
	djnz spl_lp
;check words
	ld de,kwords
	ld c,0
cwlp1:
	ld b,8
	ld hl,de
	ld ix,kbuf
cwlp2:
	ld a,(hl)
	cp (ix+0)
	jp nz,nomatch
	inc hl
	inc ix
	djnz cwlp2
;	inc c
	ld a,c,(level),a
	ld a,"+",(tx4+2),a
	jp pasprn;jr $
nomatch:
	ld hl,8
	add hl,de
	ld de,hl
	inc c
	bit 3,c
	jr z,cwlp1
	ld a,"-",(tx4+2),a
	jp pasprn

key0:
	ld a,$EF:in a,($FE)
	bit 0,a:jp nz,keylp
;check qaop
	ld a,(tx3+2)
	or a:jp p,noqaop
;fill key data
	ld a,$DF,(klp+1),a
	ld a,2,(klb+1),a

	ld a,$DF,(krp+1),a
	ld a,1,(krb+1),a

	ld a,$FB,(kup+1),a
	ld a,1,(kub+1),a

	ld a,$FD,(kdp+1),a
	ld a,1,(kdb+1),a

	ld a,$7F,(kfp+1),a
;	ld a,4,(kfb+1),a
	ld a,1,(kfb+1),a

noqaop:
	ld a,(tx6+2)
	or a:jp p,no67890
;fill key data
	ld a,$EF,(klp+1),a
	ld a,16,(klb+1),a

	ld a,$EF,(krp+1),a
	ld a,8,(krb+1),a
; 6 (left), 7 (right), 8 (down), 9 (up) and 0 (fire)
	ld a,$EF,(kup+1),a
	ld a,2,(kub+1),a

	ld a,$EF,(kdp+1),a
	ld a,4,(kdb+1),a

	ld a,$EF,(kfp+1),a
	ld a,1,(kfb+1),a

no67890:
gamb:
	ld a,$38:call cls
;	ld hl,$4000,de,$4001,bc,6143,(hl),l:ldir
;	call build_map
;-------------------------------------------------------------------

	ld hl,newmap
	ld a,(level)
	and 3
	add a,a
	add a,a
	add a,a
	ld e,a,d,0
	add hl,de
	ld de,gamemap,bc,48:ldir
; tiles #
	ld a,(level)
	ld bc,tiles
	and 4:jr z,notnum
	ld bc,tiles2
notnum:
	ld (tiles_a),bc
;-------------------------------------------------------------------
;	call draw_map
;	jr $
;fill category #
	ld hl,temptab
	xor a
	ld (hl),a
	inc l
fc1:
	ld b,3
fc2:
	ld (hl),a:inc hl:djnz fc2
	inc a
	cp 49:jr nz,fc1
;	jr $
;init vars
	ld hl,0,(pxy),hl
	call reset_tt
	xor a:ld (state),a
	ld a,16,(t_am),a
;draw empty
	call drawplace
glp2:
	call xorcur
gamelp:
klp:	ld a,$F7; 5 left
	in a,($FE)
klb:	and 16
	jp nz,keyr
	ld a,(pxy)
	or a:jp z,gamelp
	push af
	ei:halt
	call xorcur
	pop af
	dec a
endlk:
	ld (pxy),a
endlk2:
	call xorcur
	ld b,10/2
wkp: ei:halt:djnz wkp
	jp gamelp
keyr:
krp:	ld a,$EF ; 8 right
	in a,($FE)
krb:	and 4
	jp nz,keyu

	ld a,(pxy)
	cp 7:jp z,gamelp
	push af
	ei:halt
	call xorcur
	pop af
	inc a
;	ld (pxy),a
;	call xorcur
	jp endlk;gamelp

keyu:
kup:	ld a,$EF ;7 up
	in a,($FE)
kub:	and 8
	jp nz,keyd

	ld a,(pxy+1)
	or a:jp z,gamelp
	push af
	ei:halt
	call xorcur
	pop af
	dec a
enduk:
	ld (pxy+1),a
	jp endlk2
keyd ; 6 down
kdp:	ld a,$EF
	in a,($FE)
kdb:	and 16
	jp nz,keyf;gamelp

	ld a,(pxy+1)
	cp 5:jp z,gamelp
	push af
	ei:halt
	call xorcur
	pop af
	inc a
	jp enduk
keyf: ;Enter
	ld a,$BF:in a,($FE):and 1:jr z,enterok
kfp:	ld a,$EF ; BF
	in a,($FE)
kfb:	and 1
	jp nz,gamelp
enterok:
;0 - empty tile
;1-48 - hidden tiles, if b7=1 - opened tile
	ld de,(pxy)
	ld a,d
	add a,a
	add a,a
	add a,a
	add a,e
	ld e,a
	ld d,gamemap/256
	ld a,(de)
	or a:jp z,gamelp ; if 0 empty tile
	jp m,gamelp ; if b7=1 opened tile
;check status
	ld bc,(state)
	inc c:dec c:jp z,case0
	dec c:jp z,case1
;2
	ld (tilet+2),a
	push af
	or 128
	ld (de),a
;draw opened tile
	ld de,(pxy)
	call getadr; HL=addr
	pop af
	dec a
	ld d,a,e,0
	srl d
	rr e
	ex de,hl
	ld bc,(tiles_a)
	add hl,bc
	ex de,hl
	call animtile;putempty;(de)->(hl)
;; check category
	ld ix,tilet
	ld h,temptab/256
	ld l,(ix+0)
	ld a,(hl)
	ld l,(ix+1)
	ld c,(hl)
	cp (hl)
	jp nz,noteq2
	ld l,(ix+2)
	cp (hl)
	jp nz,noteq2
	ld a,c
	cp (hl)
	jp nz,noteq2

	call dlay2
	call erase3
	xor a:ld (state),a
	ld a,(t_am)
	dec a
	ld (t_am),a
;draw cursor too
;	or a
	jp nz,glp2
;	jr $
; level done
	ld a,(level)
	inc a
	and 7
	ld (level),a
;----------------------------------------------------------------------------------------------
;final cut
drwfin:
;copy word
	ld a,(level)
	add a,a
	add a,a
	add a,a
	ld de,kwords
	ld h,0,l,a
	add hl,de
	ld de,msg1
	ld b,4
copw:
	ld a,(hl):inc hl
	add a,a
	add a,a
	add a,a
	add a,a
	or (hl):inc hl
	ld (de),a
	inc de
	djnz copw

scrp=$4809+4*32
	ld c,0
m1:
	ld de,scrp
	ld ix,msg
m2:
m3:
	ld a,(ix+0)
	inc ix
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	push bc
	ld bc,myfont-256
	add hl,bc
	pop bc
	
;	ld h,15
;	add hl,hl
;	add hl,hl
	
	push de
	ld b,8

	ld a,c
	or a
	jr z,c0
	dec a
	jr z,c1
	dec a
	jr z,c2
	dec a
	jr z,c3
nxtc:
	inc c
	bit 2,c
	jr z,nowa
	ei
	halt
nowa:
	res 2,c
	ld a,(ix+0)
	or a
	jp z,m1
	jp m3
c0:
c_0:
	ld a,(hl)
	add a,a
	ld (de),a
	inc hl
	inc d
	djnz c_0
ende:
	pop de
	ld a,$7F:in a,($FE)
	rra:jp nc,gamb
	inc e
	jr nxtc
c1:
	inc hl
	jr c_3
c2:
c_2:
	ld a,(hl)
	srl a
	ld (de),a
	inc hl
	call nbde
	djnz c_2
	xor a
	ld (de),a
	jr ende
c3:
	xor a
	ld (de),a
	inc d
c_3:
	ld a,(hl)
	ld (de),a
	inc hl
	call nbde
	djnz c_3
	jr ende
msg:
 db "keyword:"
msg1: db "BEER ",0
myfont: incbin "boxed_22.fnt"
 db 0,0,4,136,80,32,0,0 ; +extra char -check

tx1:
	dw $4806
	db "Match 3 by g0blinish",0

tx2:
	dw $4847
	db 128,"1.Control:cursor",0

tx3:
	dw $4867
	db " 2.Control:QAOPsp",0

tx4:
	dw $4887+32
	db " 4.pass:"
tx44: db "BEER",0

tx5:
	dw $48A7+32
	db " 0.Start game",0

tx6:
	dw $4887
	db " 3.Control:67890",0


kwords:
 db 4,2,4,5,4,5,5,2
 db 5,0,4,1,4,9,4,14
 db 4,7,4,1,4,13,4,5
 db 5,3,5,4,4,15,5,0
 db 4,12,5,5,4,3,4,11
 db 4,12,4,5,4,5,5,4
 db 5,2,4,1,5,2,4,5
 db 4,8,4,15,4,12,4,5

;----------------------------------------------------------------------------------------------
;0
case0:
	ld (tilet),a
	push af
	or 128
	ld (de),a
;draw opened tile
	ld de,(pxy)
	call getadr; HL=addr
	pop af
	dec a
	ld d,a,e,0
	srl d
	rr e
	ex de,hl
	ld bc,(tiles_a)
	add hl,bc
	ex de,hl
	call animtile;putempty;(de)->(hl)
	ld a,1,(state),a
;draw cursor too
	jp glp2
;1
case1:
	ld (tilet+1),a
	push af
	or 128
	ld (de),a
;draw opened tile
	ld de,(pxy)
	call getadr; HL=addr
	pop af
	dec a
	ld d,a,e,0
	srl d
	rr e
	ex de,hl
	ld bc,(tiles_a)
	add hl,bc
	ex de,hl
	call animtile;putempty;(de)->(hl)
;; check category
	ld ix,tilet
	ld h,temptab/256
	ld l,(ix+0)
	ld a,(hl)
	ld l,(ix+1)
	cp (hl)
	jp nz,noteq2
	ld a,2,(state),a
;draw cursor too
	jp glp2
noteq2
	xor a:ld (state),a
	call dlay2
	call reset_all
	jp glp2
dlay2: ld b,20
dlay: ei:halt:djnz dlay
	ret
;;;;;;;;;;;;;;; V A R I A B L E ;;;;;;;;;;;;;;;
state: db 0 ;state of opened tiles
pxy: dw 0 ;player X,Y
tilet: db 0,0,0
t_am: db 16
level: db 0
tiles_a: dw tiles
kbuf ds 10
;;;;;;;;;;;;;;; R O U T I N E S ;;;;;;;;;;;;;;;
cls:
	ld hl,$4000,de,$4001,bc,6143,(hl),l:ldir
	ld hl,$5800,de,$5801,bc,767,(hl),a:ldir
	ret
wk:
	xor a:in a,($fe)
	cpl
	and 31
	jr nz,wk
	ret

getkey:
tt:	call ks
;B=high port,E=bit weight
	or a
	jr z,tt
	ret
ks:
		ld	ix, chartab
		ld	l, 8;key pars count
		ld	bc, $FEFE

kslp:
		ld	e, 1
		ld	d, 5

rowkey:
		in	a, (c)
		and	e
		jr	nz, nokey
		ld a,(ix+0)
		ret
nokey:
		sla	e
		inc	ix
		dec	d
		jr	nz, rowkey
		rlc	b
		dec	l
		jr	nz, kslp
		xor a
		ret
chartab
	db $0B,"ZXCV"
	db "ASDFG"
	db "QWERT"
	db "12345"
	db "09876"
	db "POIUY"
	db $0D,"LKJH"
	db 32,$0C,"MNB"


prtext:
	ld e,(hl):inc hl
	ld d,(hl):inc hl
prlop:
	ld a,(hl):inc hl
	or a:ret z
	push hl
	ld l,a,h,0,bc,myfont-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,8
	push de
pr8l:
	ld a,(hl),(de),a
	inc hl,d
	djnz pr8l
	pop de
	pop hl
	inc e
	jr prlop
erase3:
	ld ix,gamemap
	ld d,0
eryl:
	ld e,0
erxl:
	bit 7,(ix+0)
	jp z,ranx_
	ld (ix+0),0
	call getadr ;HL=address
	push de
	ld de,zerot ; $C000
	call putempty
	pop de
ranx_:
	inc ix
	inc e
	bit 3,e
	jr z,erxl
	inc d
	ld a,d
	cp 6
	jr nz,eryl
	ret

reset_all:
	ld ix,gamemap
	ld d,0
rayl:
	ld e,0
raxl:
	bit 7,(ix+0)
	jp z,ranx
	res 7,(ix+0)
	call getadr ;HL=address
	push de
	ld de,empty
	call putempty
	pop de
ranx:
	inc ix
	inc e
	bit 3,e
	jr z,raxl
	inc d
	ld a,d
	cp 6
	jr nz,rayl
	ret

draw_map:
	ld ix,gamemap
	ld d,0
dyl:
	ld e,0
dxl:
	call getadr ;HL=address
	ld a,(ix+0)
;	inc (ix+0)
	inc ix
	dec a
	push de
	ld d,a,e,0
	srl d
	rr e
	ex de,hl
	ld bc,(tiles_a)
	add hl,bc
	ex de,hl
	call putempty;(de)->(hl)
	pop de
	inc e
	bit 3,e
	jr z,dxl

	inc d
	ld a,d
	cp 6
	jr nz,dyl
	ret
;build_map:
;	ld hl,newmap+0,de,gamemap,bc,48:ldir
;	ret
; reset table
;	ld hl,temptab
;restlp: ld (hl),0:inc l:jr nz,restlp
;	ld hl,gamemap
;builp:
;	call random
;g47: sub 47
;	jr nc,g47
;	add a,47
;	ld e,a
;	ld d,temptab/256
;	ld a,(de)
;	or a
;	jr nz,builp
;	ld a,1,(de),a ;mark place
;	ld (hl),e
;	inc l
;	ld a,l
;	cp 47
;	jr nz,builp
;	ret

;;build
;;	ld hl,gamemap
;;	ld b,48
;;bulp:
;;	ld (hl),l
;;	inc (hl)
;;	inc l
;;	djnz bulp
;;;mix
;;	ld hl,gamemap
;;	ld de,gamemap+1;47
;;	ld b,47;24
;;	call random
;;mixlp:
;;	add a,a
;;	jr nc,noswap
;;	push af
;;	ld c,(hl)
;;	ld a,(de)
;;	ld (hl),a
;;	ld a,c
;;	ld (de),a
;;	pop af
;;noswap:
;;	or a
;;	call z,random
;;	inc hl
;;	inc de;dec de
;;	djnz mixlp
;;	ret

random  PUSH BC:LD A,(R1),C,A
        LD A,(R2):ADD A,C:LD C,A
        LD (R1),A,A,(R3)
        SUB C:LD C,A,(R2),A
        RRCA:LD (R3),A
        LD A,C:POP BC
        RET
R1      DB #16
R2      DB #70
R3      DB #FD

reset_tt:
	push hl
	ld hl,0
	ld (tilet),hl
	ld (tilet+1),hl
	pop hl
	ret
xorcur:
	ld de,(pxy)
	call getadr ; calc address
	push hl
	ld de,xor1
	call curpart
	pop hl
	ld a,l
	add a,96
	ld l,a
	inc h,h,h,h
	ld de,xor2
;	call curpart
;	ret
curpart:
	ld c,4
cpy:
	ld b,4
	push hl
cpx:
	ld a,(de)
	xor (hl)
	ld (hl),a
	inc de
	inc l
	djnz cpx
	pop hl
	call nbhl
	dec c
	jr nz,cpy
	ret
drawplace:
	ld d,0
deylp:
	ld e,0
dexlp:
	call getadr
	push de
	ld de,empty
	call putempty
	pop de
	inc e
	bit 3,e
	jr z,dexlp
	inc d
	ld a,d
	cp 6
	jr nz,deylp
	ret
animtile:;(de)->(hl)
	inc hl,hl,hl; to right corner
	ld b,1
anima:
	ei:halt
	ld c,32
	push hl,de
animy:
	push bc,hl,de
animx:
	ld a,(de),(hl),a:inc l,de
	djnz animx
	pop de,hl
	inc de,de,de,de
	call nbhl
	pop bc
	dec c
	jp nz,animy
	inc b
	pop de,hl
	dec hl
	ld a,l
	and 3
	cp 3
	jr nz,anima
	ret
putempty: ;(de)->(hl)
	push bc
	ld b,32
pelp:
	push hl
	ld a,(de),(hl),a:inc l,de
	ld a,(de),(hl),a:inc l,de
	ld a,(de),(hl),a:inc l,de
	ld a,(de),(hl),a:inc l,de
	pop hl
	call nbhl
	djnz pelp
	pop bc
	ret
getadr: ; in : D.E= y.x, out:HL=adr

	ld h,d,l,0
	srl h
	rr l
	ld a,h
	add a,a
	add a,a
	add a,a
	add a,$40
	ld h,a
	ld a,e
	add a,a
	add a,a
	add a,l
	ld l,a
	ret

nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET
xor1:
	db %01110000,%00000000,%00000000,%00001110
	db %11000000,%00000000,%00000000,%00000011
	db %10000000,%00000000,%00000000,%00000001
	db %10000000,%00000000,%00000000,%00000001
xor2:
	db %10000000,%00000000,%00000000,%00000001
	db %10000000,%00000000,%00000000,%00000001
	db %11000000,%00000000,%00000000,%00000011
	db %01110000,%00000000,%00000000,%00001110

newmap:
 db 33,36,03,48,41,06,07,35
 db 09,04,17,12,25,32,15,16
 db 11,47,29,44,21,22,28,23
 db 13,38,27,24,19,30,31,14
 db 43,34,08,37,02,26,39,40
 db 05,42,01,20,45,46,18,10
;+extra
 db 36,03,48,41,06,07,35,33
 db 16,09,04,17,12,25,32,15
 db 47,29,44,21,22,28,23,11
empty:
 incbin"void2.bin"
tiles:
 incbin "tiles\bird1.bin"
 incbin "tiles\bird2.bin"
 incbin "tiles\bird3.bin"
tiles2:
 incbin "tiles\car1.bin"
 incbin "tiles\car2.bin"
 incbin "tiles\car3.bin"

 incbin "tiles\cat1.bin"
 incbin "tiles\cat2.bin"
 incbin "tiles\cat3.bin"

 incbin "tiles\dino1.bin"
 incbin "tiles\dino2.bin"
 incbin "tiles\dino3.bin"
 
 incbin "tiles\fish1.bin"
 incbin "tiles\fish2.bin"
 incbin "tiles\fish3.bin"
 
 incbin "tiles\girl1.bin"
 incbin "tiles\girl2.bin"
 incbin "tiles\girl3.bin"

 incbin "tiles\music1.bin"
 incbin "tiles\music2.bin"
 incbin "tiles\music3.bin"

 incbin "tiles\pc11.bin"
 incbin "tiles\pc2.bin"
 incbin "tiles\pc3.bin"

 incbin "tiles\plane1.bin"
 incbin "tiles\plane2.bin"
 incbin "tiles\plane3.bin"
 
 incbin "tiles\planet1.bin"
 incbin "tiles\planet2.bin"
 incbin "tiles\planet3.bin"

 incbin "tiles\robot1.bin"
 incbin "tiles\robot2.bin"
 incbin "tiles\robot3.bin"

 incbin "tiles\smile1.bin"
 incbin "tiles\smile2.bin"
 incbin "tiles\smile3.bin"

 incbin "tiles\tool1.bin"
 incbin "tiles\tool2.bin"
 incbin "tiles\tool3.bin"

 incbin "tiles\tree1.bin"
 incbin "tiles\tree2.bin"
 incbin "tiles\tree3.bin"

 incbin "tiles\ufo1.bin"
 incbin "tiles\ufo2.bin"
 incbin "tiles\ufo3.bin"

 incbin "tiles\war1.bin"
 incbin "tiles\war2.bin"
 incbin "tiles\war3.bin"
 
 incbin "tiles\ele1.bin"
 incbin "tiles\ele2.bin"
 incbin "tiles\ele3.bin"

zerot: ds 128
intvec:
	push ix,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL $C00E;PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop iy,ix
	ei:ret

;song:incbin "ULTRATR.pt3"
;plyr:include "PTxPlay.a80"
music_b:
 incbin "player.bin"
music_e:
end
	display /d,end-begin
	display end
	savesna "!void.sna",begin
	savebin "game.code",begin,end-begin
